// Последнее обновление 2017-05-31 by Phisik
// В рамках разгрузки кода раскидываем функции по файлам
// Здесь обработка всяких страшилок

#include "configuration.h"
#include "declarations.h"

void ReadAlarm()
{

  // Если уровень тревоги равен единице, то считаем, что датчик цифровой
  if  (USE_ALARM_VODA)
  {
    if (UROVEN_ALARM != 1)  U_VODA = analogRead(PIN_ALARM_VODA);
    else U_VODA = !digitalRead(PIN_ALARM_VODA); // Датчики влажности инверсные, то есть при не сработавшем состоянии у них на выходе 1, при сработке 0

    if (U_VODA >= UROVEN_ALARM )
    {
      CountAlarmVoda++;

#ifdef TEST
      sprintf_P(my_tx_buffer, PSTR("ALARM U_VODA=%i cnt=%i"), U_VODA, CountAlarmVoda);
      DEBUG_SERIAL.println(my_tx_buffer);
#endif

      if (CountAlarmVoda > COUNT_ALARM)
      {
        DispDopInfo = 2;
        if (IspReg == 129) DispPage = 4;
        // По прошествии минуты устанавливаем флаг сработки.
        if (CountAlarmVoda > COUNT_ALARM_VODA)
        {
          DispDopInfo = 0;
#ifndef TEST
#ifndef DEBUG
          IspReg = 250;    // Переводим контроллер в режим тревоги, если не установлен тестовый режим.
#endif
#endif
        }
      }
    }
    else
    {
      if (DispDopInfo == 2)
      {
        DispDopInfo = 0;
      }
      CountAlarmVoda = 0;
    }
  }

  if (USE_ALARM_UROVEN)
  {
    if (UROVEN_ALARM > 1) {
      // Считаваем значение аналоговое  датчика
      U_UROVEN = analogRead(PIN_ALARM_UROVEN);
    } else {
      // Считаваем значение цифрового датчика
      // Датчики влажности инверсные, то есть при не сработавшем состоянии у них на выходе 1, при сработке 0
      U_UROVEN = !digitalRead(PIN_ALARM_UROVEN);
    }

    // Для фракционной перегонки первой фракции считаем сработкой датчика уровня также и сработку датчика голов.
    // Чтобы можно было отбирать головы через один клапан, тело через другой без фракционника.
    if (IspReg == 117 && TekFraction == 0)
    {
      if (UROVEN_ALARM != 1)
        U_UROVEN = U_UROVEN + analogRead(PIN_PROVODIMOST_SR);
      else
        U_UROVEN = U_UROVEN || !digitalRead(PIN_PROVODIMOST_SR); // Датчики влажности инверсные, то есть при не сработавшем состоянии у них на выходе 1, при сработке 0

    }
    // Предупреждение по уровню генерируем только уже не произошла сработка уроня
    // Если произошла, то уже смысла анализировать нет
    if (U_UROVEN >= UROVEN_ALARM  && flAlarmUroven == 0)
    {
      CountAlarmUroven++;
#ifdef TEST
      sprintf_P(my_tx_buffer, PSTR("ALARM U_UROVEN=%i cnt=%i"), U_UROVEN, CountAlarmUroven);
      DEBUG_SERIAL.println(my_tx_buffer);
#endif
      if (CountAlarmUroven > COUNT_ALARM )
      {
        DispDopInfo = 1;
        // По прошествии минуты устанавливаем флаг сработки.
        if (CountAlarmUroven > COUNT_ALARM_UROVEN || ((IspReg == 117 || IspReg == 118) && CountAlarmUroven > COUNT_ALARM_UROVEN_FR) )
        {
          flAlarmUroven = 1;
          flNeedAnalyse = 1;
          DispDopInfo = 0;
        }
      }
    }
    else
    {
      if (DispDopInfo == 1)
      {
        DispDopInfo = 0;
      }
      CountAlarmUroven = 0;
    }
  }

  if (UrovenProvodimostSR != 0 || IspReg == 112 || FlState == 232 || IspReg == 129) // Читаем датчик уровня голов, если установлено, что его надо читать.
  {
    if (UrovenProvodimostSR != 1) U_GLV = analogRead(PIN_PROVODIMOST_SR);
    else U_GLV = !digitalRead(PIN_PROVODIMOST_SR); // Датчики влажности инверсные, то есть при не сработавшем состоянии у них на выходе 1, при сработке 0
  }
}
